<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Ward</title>
</head>
<body>
    <div class="container">
        <div class="d-flex justify-content-center mt-5">
        <div class="card card-danger w-50">
            <div class="card-header">
                <h3 class="card-title">Phường, xã</h3>
            </div>
            <div class="card-body">
                <div class="row form-group">
                    <label for="" class="col-sm-3">Tên</label>
                    <div class="col-sm-9">
                        <input id="inp-ward" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <label for="" class="col-sm-3">Phường xã</label>
                    <div class="col-sm-9">
                        <select name="prefix" id="select-prefix" class="form-control">
                            <option value="none">Phường, xã</option>
                            <option value="1">Xã</option>
                            <option value="2">Phường</option>
                            <option value="3">Thị Trấn</option>
                        </select>
                    </div>
                </div>

                <div class="row form-group">
                    <label for="" class="col-sm-3">Quận huyện</label>
                    <div class="col-sm-9">
                        <select name="prefix" id="select-district" class="form-control">
                            <option value="none">Quận-Huyện</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <label for="" class="col-sm-3">Tỉnh thành</label>
                    <div class="col-sm-9">
                        <select name="province" id="select-province" class="form-control">
                            <option value="none">Tỉnh</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-6">
                        <button id="btn-add" class="btn btn-primary">Add</button>
                        <button id="btn-update" class="btn btn-primary" style="display: none;">Update</button>
                        <button id="btn-delete" class="btn btn-danger" style="display: none;">Delete</button>
                        <button id="btn-cancel" class="btn btn-secondary">Cancel</button>
                        
                    </div>
                </div>
                
            </div>
        </div>

    </div>
    <table id="table-ward" class="table table-stripped table-bordered table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>Xã, Phường</th>
                <th>Tên</th>
            </tr>
        </thead>
        <tbody>

        </tbody>
    </table>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableWard = $("#table-ward").DataTable({
        columns: [
            { data: "id"},
            { data: "prefix"},
            { data: "name"}
        ]
    });

    var gDistrictId = null;
    var gWardId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    // Thực thi sự kiện chọn province thì load ra list district của province đó trong thẻ select
    $("#select-province").on("change", function() {
        callApiToLoadDataToSelectDistrict();
    });

    // Thực thi sự kiện chọn district thì load ra list ward ra table
    $("#select-district").on("change", function() {
        callApiToLoadWardToTable();
    });

    // Thực thi sự kiện nhấn nút add
    $("#btn-add").on("click", function() {
        onBtnAddClick();
    })

    // Thực thi sự kiện ấn vào row
    $("#table-ward").on("click", "tr", function() {
        onClickWardRow(this);
    });

    // Thực thi sự kiện nhấn nút cancel
    $("#btn-cancel").on("click", function() {
        onBtnCancelClick();
    });

    // THực thi sự kiện nhấn nút delete
    $("#btn-delete").on("click", function() {
        onBtnDeleteClick();
    });

    // Thực thi sự kiện nhấn nút update
    $("#btn-update").on("click", function() {
        onBtnUpdateClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    function onPageLoading() {
        callApiloadToSelectProvince();
    }

    
    // Hàm xử lý sự kiện nhấn nút add ward
    function onBtnAddClick() {
        var vNewWard = {
            name: "",
            prefix: ""
        }
        getNewWardData(vNewWard);
        var vValidate = validateWard(vNewWard);
        console.log(vNewWard);
        if(vValidate) {
            callApiToCreateNewWard(vNewWard);
        }
    }   

    // Hàm xử lý sự kiện nhấn nút add ward
    function onBtnUpdateClick() {
        var vNewWard = {
            name: "",
            prefix: ""
        }
        getNewWardData(vNewWard);
        var vValidate = validateWard(vNewWard);
        console.log(vNewWard);
        if(vValidate) {
            callAPiToUpdateWard(vNewWard);
        }
    }

    // Hàm xử lý sự kiện nhấn vào row ward
    function onClickWardRow(paramRow) {
        var vDataRow = gTableWard.row(paramRow).data();
        console.log(vDataRow);
        gWardId = vDataRow.id;
        $("#inp-ward").val(vDataRow.name);
        console.log(vDataRow.prefix);
        if(vDataRow.prefix == "Xã") {
            $("#select-prefix").val(1);

        } 
        if(vDataRow.prefix == "Phường") {
            $("#select-prefix").val(2);
        } 
        if(vDataRow.prefix == "Thị trấn") {
            $("#select-prefix").val(3);
        } 
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();
    }

    // Hàm sự kiện nhất nút cancel
    function onBtnCancelClick() {
        clearData();
    }

    // Hàm sự kiện nhấn nút delete
    function onBtnDeleteClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/ward/" + gWardId,
            success: function(paramRes) {
                alert("Xóa thành công!");
                callApiToLoadWardToTable();
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm load danh sách province vào thẻ select province
    function callApiloadToSelectProvince() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/provinces",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToSelectProvince(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        })
    }


    // Hàm load dữ liệu province vào thẻ select province
    function loadDataToSelectProvince(paramProvinceData) {
        var vSelectProvince = $("#select-province");
        for(var bI = 0; bI < paramProvinceData.length; bI++) {
            $("<option>", {
                value: paramProvinceData[bI].id,
                text: paramProvinceData[bI].name
            }).appendTo(vSelectProvince);
        }
    }

    // Hàm gọi API để load dữ liệu select district
    function callApiToLoadDataToSelectDistrict() {
        var vProvinceId = $("#select-province").val();
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/province/" + vProvinceId + "/districts",
            success: function(paramRes) {
                loadDataToSelectDistrict(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        });
    }

    // Hàm load dữ liệu vào select district
    function loadDataToSelectDistrict(paramDistrictData) {
        var vSelectDistrict = $("#select-district");
        vSelectDistrict.html("");
        for(var bI = 0; bI < paramDistrictData.length; bI++) {
            $("<option>", {
                value: paramDistrictData[bI].id,
                text: paramDistrictData[bI].prefix + " "  + paramDistrictData[bI].name
            }).appendTo(vSelectDistrict);
        }
    }

    // Hàm call Api để load list ward ra table
    function callApiToLoadWardToTable() {
        var vDistrictId = $("#select-district").val();
        $.ajax({
            type: "GET", 
            url: "http://localhost:8080/district/" + vDistrictId + "/wards",
            success: function(paramRes) {
                loadDataToTable(paramRes);
            },
            error: function(error) {
                console.log(error.status);
            }
        })
    }

    // Hàm load dữ liệu vào table
    function loadDataToTable(paramWardData) {
        gTableWard.clear();
        gTableWard.rows.add(paramWardData);
        gTableWard.draw();
    }

    // Hàm lấy thông tin ward từ form
    function getNewWardData(paramDataWard) {
        paramDataWard.name = $("#inp-ward").val();
        paramDataWard.prefix = $("#select-prefix option:selected").text();
    }

    // Hàm validate dữ liệu
    function validateWard(paramDataWard) {
        if(paramDataWard.name == "") {
            alert("Vui lòng nhập Ward");
            return false;
        }
        if(paramDataWard.prefix == "Phường, xã") {
            alert("Vui lòng chọn prefix");
            return false;
        }
        return true;
    }

    // Hàm gọi API để tạo mới 1 ward
    function callApiToCreateNewWard(paramDataWard) {
        var vDistrictId = $("#select-district").val();
        $.ajax({
            type: "POST", 
            url: "http://localhost:8080/district/" + vDistrictId + "/wards",
            contentType: "application/json",
            data: JSON.stringify(paramDataWard),
            success: function(paramRes) {
                alert("Tạo mới thành công!");
                callApiToLoadWardToTable();
            },
            error: function(error) {
                alert("Tạo mới thất bại");
                console.log(error.status);
            }
        })
    }

    // Hàm clear data
    function clearData() {
        gTableWard.clear();
        gTableWard.rows.add("");
        gTableWard.draw();
        $("#select-province").val("none");
        var vSelectDistrict = $("#select-district");
        vSelectDistrict.html("");
        $("<option>", {
            value: "none",
            text: "Quận-Huyện"
        }).appendTo(vSelectDistrict);
        $("#inp-ward").val("");
        $("#select-prefix").val("none");
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
    }

    // Gọi API Để sửa 1 ward
    function callAPiToUpdateWard(paramDataWard) {
        $.ajax({
            type: "PUT", 
            url: "http://localhost:8080/ward/" + gWardId,
            contentType: "application/json",
            data: JSON.stringify(paramDataWard),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                callApiToLoadWardToTable();
            },
            error: function(error) {
                alert("Cập nhật thất bại");
                console.log(error.status);
            }
        })
    }

</script>
</html>